﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Xml;

using Tridion.ContentManager.Extensibility.Events;
using Tridion.ContentManager.Extensibility;
using Tridion.ContentManager.ContentManagement;
using Tridion.ContentManager.Publishing;
using Tridion.ContentManager;
using Tridion.ContentManager.CommunicationManagement;

namespace Tridion.Extensions
{
    
    public class TridionPublishQueue
    {
        private static string RemoteUser = "";
        private static Int32 QueueLength = 0;
        private static string Queue = "";
        public XmlNodeList QueueNodes;
        private static PublishTransaction PublishTransaction;
        private static Filter QueueFilter = new Filter();

        public TridionPublishQueue(HttpRequest Request, String Queue) //, Int32 daysBack, String date)
        {
            RemoteUser = Request.ServerVariables["REMOTE_USER"];
            TridionPublishQueue.Queue = Queue;
            int daysBack = 1;
            int hours = 0;
            string date = "";
            
            // set the filters for the queue
            QueueFilter.Conditions["InfoType"] = TridionPublishQueue.Queue;

            if (Request.QueryString["daysback"] != null)
                daysBack = Convert.ToInt32(Request.QueryString["daysback"]);
            if (Request.QueryString["hours"] != null)
                hours = Convert.ToInt32(Request.QueryString["hours"]);
            if (Request.QueryString["date"] != null)
                date = Request.QueryString["date"];     

            if (daysBack > 0)
            {
                // convert to a negative
                daysBack = daysBack * -1;
                // create DateTime object
                DateTime dt = new DateTime();
                dt = DateTime.Now;

                // set queue filters for date ranges
                QueueFilter.Conditions["EndDate"] = dt;
                dt = dt.AddDays(daysBack);
                QueueFilter.Conditions["StartDate"] = dt;
            }
            if (date.Length > 0)
            {
                string startDate = date + " 00:00:00 AM";
                string endDate = date + " 11:59:59 PM";

                DateTime startDt = new DateTime();
                DateTime endDt = new DateTime();
                startDt = DateTime.Parse(startDate);
                endDt = DateTime.Parse(endDate);

                // set queue filters for date ranges
                QueueFilter.Conditions["StartDate"] = startDt;
                QueueFilter.Conditions["EndDate"] = endDt;
            }
        }

        public PublishTransaction GetPublishTransaction(string PublishTransactionId)
        {
            Session TridionSession = new Session(RemoteUser);
            return (PublishTransaction) TridionSession.GetObject(PublishTransactionId);
        }


        // returns true if the queue has no issues
        public bool GetQueueState(Int32 Max)
        {
            GetQueue();
            int ItemsCount = QueueNodes.Count;
            if (ItemsCount > Max) {
                //QueueLength = ItemsCount;
                return false;
            } else {
                //QueueLength = ItemsCount;
                return true;
            }
        }

        public void GetQueue()
        {
            Session TridionSession = new Session(RemoteUser);
            

            XmlElement QueueTransactionElement = TridionSession.GetList(typeof(PublishTransaction), QueueFilter);
            XmlDocument QueueItems = QueueTransactionElement.OwnerDocument;
            QueueNodes = QueueItems.SelectNodes("tcm:ListPublishTransactions/tcm:Item", GetNamespace(QueueItems.NameTable));      
        }

        public Int32 GetQueueLength()
        {
            //GetQueue();
            return QueueNodes.Count;
        }

        public XmlNamespaceManager GetNamespace(XmlNameTable nameTable)
        {
            XmlNamespaceManager NamespaceManager = new XmlNamespaceManager(nameTable);
            NamespaceManager.AddNamespace("tcm", "http://www.tridion.com/ContentManager/5.0");
            return NamespaceManager;
        }
    }
}
