<%@ Page Language="C#" AutoEventWireup="true" Debug="true" %>
<%@ Import namespace="Tridion.Extensions" %>
<%@ Import namespace="System.Xml" %>
<%@ Import namespace="Tridion.ContentManager.Publishing" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
<title>Queue View (Graphical)</title>
<link rel="Stylesheet" href="style.css" type="text/css" />
</head>
<body> 
<div>
<%     
TridionPublishQueue tpq = new TridionPublishQueue(Request, "6"); //, daysBack, date); // load the queue
    
String transactionId;
DateTime dateTransactionStart;
DateTime dateLastStatusChange;
TimeSpan tsDuration;
TimeSpan tsTotalSubItemRenderTime = new TimeSpan();
TimeSpan tsSubItemRenderTime = new TimeSpan();
	
TimeSpan good = new TimeSpan(0,0,0,5);
TimeSpan average = new TimeSpan(0, 0, 0, 10);

tpq.GetQueue();
int itemsCountSuccessful = tpq.GetQueueLength();
if (itemsCountSuccessful>0) {
    Response.Write("<table><tr><th><strong>Transaction ID</strong></th><th><strong>Item ID</strong></th><th><strong>Item Type</strong></th><th><strong>Title</strong></th><th><strong>Publication</strong></th><th><strong>Publication Target</strong></th><th><strong>Priority</strong></th><th><strong>Action</strong></th><th><strong>User</strong></th><th><strong>Estimated Duration</strong></th><th><strong>Publish Time</strong></th><th><strong>State Change Time</strong></th><th><strong>Number of sub-items</strong></th></tr>");

    for (int i = 0; i < itemsCountSuccessful; i++)
    {
        transactionId = tpq.QueueNodes.Item(i).Attributes["ID"].Value;
        PublishTransaction publishTransaction = tpq.GetPublishTransaction(transactionId);

        dateTransactionStart = publishTransaction.Instruction.StartAt;
        dateLastStatusChange = publishTransaction.StateChangeDateTime;
        tsDuration = dateLastStatusChange - dateTransactionStart;

        foreach (PublishContext transactionContext in publishTransaction.PublishContexts)
        {
            //Response.Write(publishTransaction.Items.First().Title.ToString() + "<br/>");
            // write out the item row
            Response.Write("<tr>");
            Response.Write("<td class=\"item\">" + publishTransaction.Id + "</td>");
            Response.Write("<td class=\"item\">" + publishTransaction.Items.First().Id + "</td>");
            Response.Write("<td class=\"item\">" + publishTransaction.Items.First().Id.ItemType + "</td>");
            Response.Write("<td class=\"item\">" + publishTransaction.Items.First().Title.ToString() + "</td>");
            Response.Write("<td class=\"item\">" + transactionContext.Publication.Title.ToString() + "</td>");
            Response.Write("<td class=\"item\">" + transactionContext.PublicationTarget.Title.ToString() + "</td>");
            Response.Write("<td class=\"item\">" + publishTransaction.Priority.ToString() + "</td>");
            Response.Write("<td class=\"item\">" + publishTransaction.Instruction.ResolveInstruction.Purpose.ToString() + "</td>"); 
            Response.Write("<td class=\"item\">" + publishTransaction.Creator.Title.ToString() + "</td>");
            Response.Write("<td class=\"item\">" + tsDuration + "</td>");
            Response.Write("<td class=\"item\">" + dateTransactionStart.ToString() + "</td>");
            Response.Write("<td class=\"item\">" + dateLastStatusChange.ToString() + "</td>");
            Response.Write("<td class=\"item\">" + transactionContext.ProcessedItems.Count + "</td>");
            Response.Write("</tr>");

            Response.Write("<tr><td align=\"right\" colspan=\"13\"><table width=\"600\">");
            Response.Write("<tr><th class=\"subitem\">Sub Item ID</th><th class=\"subitem\">Render Type</th><th class=\"subitem\">Template Id</th><th class=\"subitem\">Render Time</th></tr>");

            tsTotalSubItemRenderTime = new TimeSpan(0, 0, 0, 0, 0);
            foreach (ProcessedItem processedItem in transactionContext.ProcessedItems)
            {

                String strSubItemTemplateId = "N/A";
                String strSubItemRenderType = "";
                    
                tsSubItemRenderTime = new TimeSpan(0, 0, 0, 0, processedItem.RenderTime.Milliseconds); ; ;//TimeSpan.Parse(strSubItemRenderTime);
                tsTotalSubItemRenderTime = tsTotalSubItemRenderTime.Add(tsSubItemRenderTime);
                    
                if (processedItem.ResolvedItem.Item.Id.ItemType.ToString().Equals("Component"))
                {
                    strSubItemRenderType = "Component Presentation";
                    strSubItemTemplateId = processedItem.ResolvedItem.Template.Id;
                }
                else if (processedItem.ResolvedItem.Item.Id.ItemType.ToString().Equals("Category"))
                {
                    strSubItemRenderType = "Category";
                } else {
                    strSubItemRenderType = "Page";
                }
                    
                String color = "#33CC33";
                if (TimeSpan.Compare(tsSubItemRenderTime, good) == 1)
                {
                    if (TimeSpan.Compare(tsSubItemRenderTime, average) == -1 || TimeSpan.Compare(tsSubItemRenderTime, average) == 0)
                    {
                        color = "#EEDD11";
                    }
                }
                if (TimeSpan.Compare(tsSubItemRenderTime, average) == 1)
                {
                    color = "#FF1111";
                }

                Response.Write("<tr>");
                Response.Write("<td>" + processedItem.ResolvedItem.Item.Id + "</td>");
                Response.Write("<td>" + strSubItemRenderType + "</td>");
                Response.Write("<td>" + strSubItemTemplateId + "</td>");
                Response.Write("<td bgcolor=\"" + color + "\">" + tsSubItemRenderTime.ToString() + "</td>");
                Response.Write("</tr>");
            }
            Response.Write("<tr><td colspan=\"2\"><strong>Total Render Time:</strong> " + tsTotalSubItemRenderTime.ToString() + "</td><td colspan=\"2\"><strong>Estimated Deployment Time:</strong> " + tsDuration.Subtract(tsTotalSubItemRenderTime) + "</td></tr>");
            Response.Write("</table></td></tr>");
        }
    }
    Response.Write("</table><br/>");
} else {
    Response.Write ("No queue items found");
}
%>
</div>
</body>
</html>
