<%@ Page Language="C#" AutoEventWireup="true" Debug="true" %>
<%@ Import namespace="Tridion.Extensions" %>
<%@ Import namespace="System.Xml" %>
<%@ Import namespace="Tridion.ContentManager.Publishing" %>
<%
TimeSpan tsTotalSubItemRenderTime = new TimeSpan();
TimeSpan tsSubItemRenderTime = new TimeSpan();
	
DateTime dateTransactionStart;
DateTime dateLastStatusChange;
TimeSpan tsDuration;
TimeSpan tsMaxDuration = new TimeSpan(0, 0, 0);
TimeSpan tsMinDuration = new TimeSpan(99, 99, 99);	

String transactionId;
TridionPublishQueue tpq = new TridionPublishQueue(Request, "6"); //, daysBack, date); // load the queue

tpq.GetQueue();
int itemsCountSuccessful = tpq.GetQueueLength();
       	
if (itemsCountSuccessful>0) {
        
    Response.Write("transactionId|");
    Response.Write("itemId|");
    Response.Write("itemType|");
    Response.Write("itemTitle|");
    Response.Write("publicationTitle|");
    Response.Write("target|"); 
    Response.Write("priority|");
    Response.Write("action|"); 
    Response.Write("username|");
    Response.Write("duration|");
    Response.Write("publishTime|");
    Response.Write("StateChangeDate|");
    Response.Write("itemsCountTotal|");
    Response.Write("totalSubItemRenderTime|");
    Response.Write("estimatedDeploymentTime");
    Response.Write("<br/>");
        
	for (int i = 0; i < itemsCountSuccessful; i++) {
		
	    transactionId = tpq.QueueNodes.Item(i).Attributes["ID"].Value;
        PublishTransaction publishTransaction = tpq.GetPublishTransaction(transactionId);

		dateTransactionStart = publishTransaction.Instruction.StartAt;
        dateLastStatusChange = publishTransaction.StateChangeDateTime;
        tsDuration = dateLastStatusChange - dateTransactionStart;
			
		if (tsDuration > tsMaxDuration)
            tsMaxDuration = tsDuration;

        if (tsDuration < tsMinDuration)
            tsMinDuration = tsDuration;

        foreach (PublishContext transactionContext in publishTransaction.PublishContexts)
        {
            String itemId = publishTransaction.Items.First().Id; 
            String itemTitle = publishTransaction.Items.First().Title.ToString().Replace("|", "");
            String itemType = publishTransaction.Items.First().Id.ItemType.ToString(); 
            String publicationTitle = transactionContext.Publication.Title.ToString(); 
            String publicationTarget = transactionContext.PublicationTarget.Title.ToString(); 
            String username = publishTransaction.Creator.Title.ToString(); 
            String priority = publishTransaction.Priority.ToString();
            String action = publishTransaction.Instruction.ResolveInstruction.Purpose.ToString(); 
            int itemsCountTotal = transactionContext.ProcessedItems.Count; 

            foreach (ProcessedItem processedItem in transactionContext.ProcessedItems)
            {
                String strSubItemId = "";
                String strSubItemRenderTime = "";
                String strSubItemTemplateId = "N/A";
                String strSubItemRenderType = "";
                
                strSubItemId = processedItem.ResolvedItem.Item.Id;
                if (processedItem.ResolvedItem.Item.Id.ItemType.ToString().Equals("Component"))
                {
                    strSubItemRenderType = "Component Presentation";
                    strSubItemTemplateId = processedItem.ResolvedItem.Template.Id;
                }
                else if (processedItem.ResolvedItem.Item.Id.ItemType.ToString().Equals("Category"))
                {
                    strSubItemRenderType = "Category";
                } else {
                    strSubItemRenderType = "Page";
                }
                tsSubItemRenderTime = new TimeSpan(0, 0, 0, 0, processedItem.RenderTime.Milliseconds);
                tsTotalSubItemRenderTime = tsTotalSubItemRenderTime.Add(tsSubItemRenderTime);
                        
            }
            Response.Write(transactionId + "|");
            Response.Write(itemId + "|");
            Response.Write(itemType + "|");
            Response.Write(itemTitle + "|");
            Response.Write(publicationTitle + "|");
            Response.Write(publicationTarget + "|"); 
            Response.Write(priority + "|");
            Response.Write(action + "|"); 
            Response.Write(username + "|");
            Response.Write(tsDuration + "|");
            Response.Write(tsSubItemRenderTime.ToString() + "|");
            Response.Write(dateLastStatusChange.ToString() + "|");
            Response.Write(itemsCountTotal + "|");
            Response.Write(tsTotalSubItemRenderTime.ToString() + "|");
            Response.Write(tsDuration.Subtract(tsTotalSubItemRenderTime));
            Response.Write("<br/>");
        }    
    }        
} else {
    Response.Write ("No queue items found");
}
%>
